<html>
<head>
<title>OgreMemoryNedPooling.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreMemoryNedPooling.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreMemoryNedPooling_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifndef __MemoryNedPooling_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define __MemoryNedPooling_H__</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="preprocessor">#if OGRE_MEMORY_ALLOCATOR == OGRE_MEMORY_ALLOCATOR_NEDPOOLING</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre
<a name="l00036"></a>00036 {
<a name="l00045"></a><a class="code" href="classOgre_1_1NedPoolingImpl.html">00045</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1NedPoolingImpl.html" title="Non-templated utility class just to hide nedmalloc.">NedPoolingImpl</a>
<a name="l00046"></a>00046     {
<a name="l00047"></a>00047     <span class="keyword">public</span>:
<a name="l00048"></a>00048         <span class="keyword">static</span> <span class="keywordtype">void</span>* allocBytes(<span class="keywordtype">size_t</span> count, 
<a name="l00049"></a>00049             <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">int</span> line, <span class="keyword">const</span> <span class="keywordtype">char</span>* func);
<a name="l00050"></a>00050         <span class="keyword">static</span> <span class="keywordtype">void</span> deallocBytes(<span class="keywordtype">void</span>* ptr);
<a name="l00051"></a>00051         <span class="keyword">static</span> <span class="keywordtype">void</span>* allocBytesAligned(<span class="keywordtype">size_t</span> align, <span class="keywordtype">size_t</span> count, 
<a name="l00052"></a>00052             <span class="keyword">const</span> <span class="keywordtype">char</span>* file, <span class="keywordtype">int</span> line, <span class="keyword">const</span> <span class="keywordtype">char</span>* func);
<a name="l00053"></a>00053         <span class="keyword">static</span> <span class="keywordtype">void</span> deallocBytesAligned(<span class="keywordtype">size_t</span> align, <span class="keywordtype">void</span>* ptr);
<a name="l00054"></a>00054 
<a name="l00055"></a>00055     };
<a name="l00056"></a>00056 
<a name="l00065"></a><a class="code" href="classOgre_1_1NedPoolingPolicy.html">00065</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1NedPoolingPolicy.html" title="An allocation policy for use with AllocatedObject and STLAllocator.">NedPoolingPolicy</a>
<a name="l00066"></a>00066     {
<a name="l00067"></a>00067     <span class="keyword">public</span>:
<a name="l00068"></a><a class="code" href="classOgre_1_1NedPoolingPolicy.html#a13e73e5a7bc0e7787da15a35c2396ff3">00068</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span>* allocateBytes(<span class="keywordtype">size_t</span> count, 
<a name="l00069"></a>00069             <span class="keyword">const</span> <span class="keywordtype">char</span>* file = 0, <span class="keywordtype">int</span> line = 0, <span class="keyword">const</span> <span class="keywordtype">char</span>* func = 0)
<a name="l00070"></a>00070         {
<a name="l00071"></a>00071             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1NedPoolingImpl.html#ac6b56adc813c89aa4d8398f8364041e9">NedPoolingImpl::allocBytes</a>(count, file, line, func);
<a name="l00072"></a>00072         }
<a name="l00073"></a><a class="code" href="classOgre_1_1NedPoolingPolicy.html#add949c266f9c3632890c4569bf436080">00073</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> deallocateBytes(<span class="keywordtype">void</span>* ptr)
<a name="l00074"></a>00074         {
<a name="l00075"></a>00075             <a class="code" href="classOgre_1_1NedPoolingImpl.html#ad2f012d0a2203f798f34206efb57556b">NedPoolingImpl::deallocBytes</a>(ptr);
<a name="l00076"></a>00076         }
<a name="l00078"></a><a class="code" href="classOgre_1_1NedPoolingPolicy.html#a6d5ebb0fcc3695cf27bb7f5981373ead">00078</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">size_t</span> getMaxAllocationSize()
<a name="l00079"></a>00079         {
<a name="l00080"></a>00080             <span class="keywordflow">return</span> std::numeric_limits&lt;size_t&gt;::max();
<a name="l00081"></a>00081         }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083     <span class="keyword">private</span>:
<a name="l00084"></a>00084         <span class="comment">// No instantiation</span>
<a name="l00085"></a><a class="code" href="classOgre_1_1NedPoolingPolicy.html#a6fc1e33d327f62bbd8599c5bbbd60d17">00085</a>         <a class="code" href="classOgre_1_1NedPoolingPolicy.html" title="An allocation policy for use with AllocatedObject and STLAllocator.">NedPoolingPolicy</a>()
<a name="l00086"></a>00086         { }
<a name="l00087"></a>00087     };
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00102"></a>00102     <span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> Alignment = 0&gt;
<a name="l00103"></a><a class="code" href="classOgre_1_1NedPoolingAlignedPolicy.html">00103</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1NedPoolingAlignedPolicy.html" title="An allocation policy for use with AllocatedObject and STLAllocator, which aligns memory at a given bo...">NedPoolingAlignedPolicy</a>
<a name="l00104"></a>00104     {
<a name="l00105"></a>00105     <span class="keyword">public</span>:
<a name="l00106"></a>00106         <span class="comment">// compile-time check alignment is available.</span>
<a name="l00107"></a>00107         <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1NedPoolingAlignedPolicy.html#a9a6d7904162746fdd20d8c5821154108">IsValidAlignment</a>
<a name="l00108"></a><a class="code" href="classOgre_1_1NedPoolingAlignedPolicy.html#a9a6d7904162746fdd20d8c5821154108">00108</a>             [Alignment &lt;= 128 &amp;&amp; ((Alignment &amp; (Alignment-1)) == 0) ? +1 : -1];
<a name="l00109"></a>00109 
<a name="l00110"></a><a class="code" href="classOgre_1_1NedPoolingAlignedPolicy.html#af448af5552f3c32f7172ae64d893d8ea">00110</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span>* <a class="code" href="classOgre_1_1NedPoolingAlignedPolicy.html#af448af5552f3c32f7172ae64d893d8ea">allocateBytes</a>(<span class="keywordtype">size_t</span> count, 
<a name="l00111"></a>00111             <span class="keyword">const</span> <span class="keywordtype">char</span>* file = 0, <span class="keywordtype">int</span> line = 0, <span class="keyword">const</span> <span class="keywordtype">char</span>* func = 0)
<a name="l00112"></a>00112         {
<a name="l00113"></a>00113             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1NedPoolingImpl.html#aecd1d58ef07f2dcb3e2f1bff7b448926">NedPoolingImpl::allocBytesAligned</a>(Alignment, count, file, line, func);
<a name="l00114"></a>00114         }
<a name="l00115"></a>00115 
<a name="l00116"></a><a class="code" href="classOgre_1_1NedPoolingAlignedPolicy.html#a39a8de46c4ae20ed51ae1a785d08a467">00116</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1NedPoolingAlignedPolicy.html#a39a8de46c4ae20ed51ae1a785d08a467">deallocateBytes</a>(<span class="keywordtype">void</span>* ptr)
<a name="l00117"></a>00117         {
<a name="l00118"></a>00118             <a class="code" href="classOgre_1_1NedPoolingImpl.html#abe7b314f9c8ee32927cf42eff59657b2">NedPoolingImpl::deallocBytesAligned</a>(Alignment, ptr);
<a name="l00119"></a>00119         }
<a name="l00120"></a>00120 
<a name="l00122"></a><a class="code" href="classOgre_1_1NedPoolingAlignedPolicy.html#a9a9c9cd828ad39ebe59b0710f90f08e0">00122</a>         <span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1NedPoolingAlignedPolicy.html#a9a9c9cd828ad39ebe59b0710f90f08e0" title="Get the maximum size of a single allocation.">getMaxAllocationSize</a>()
<a name="l00123"></a>00123         {
<a name="l00124"></a>00124             <span class="keywordflow">return</span> std::numeric_limits&lt;size_t&gt;::max();
<a name="l00125"></a>00125         }
<a name="l00126"></a>00126     <span class="keyword">private</span>:
<a name="l00127"></a>00127         <span class="comment">// no instantiation allowed</span>
<a name="l00128"></a><a class="code" href="classOgre_1_1NedPoolingAlignedPolicy.html#a45bc986478abaad34970c226ec32e1a4">00128</a>         <a class="code" href="classOgre_1_1NedPoolingAlignedPolicy.html#a45bc986478abaad34970c226ec32e1a4">NedPoolingAlignedPolicy</a>()
<a name="l00129"></a>00129         { }
<a name="l00130"></a>00130     };
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00138"></a>00138 }<span class="comment">// namespace Ogre</span>
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="preprocessor">#endif </span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>
<a name="l00142"></a>00142 <span class="preprocessor">#endif // __MemoryNedPooling_H__</span>
<a name="l00143"></a>00143 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
